package java.net;

import java.security.AccessControlContext;

final class FactoryURLClassLoader extends URLClassLoader
{
    FactoryURLClassLoader(URL[] array, ClassLoader classLoader, AccessControlContext accessControlContext) {
        super(array, classLoader, accessControlContext);
    }
    
    FactoryURLClassLoader(URL[] array, AccessControlContext accessControlContext) {
        super(array, accessControlContext);
    }
    
    public final Class<?> loadClass(String name, boolean resolve) throws ClassNotFoundException {
        SecurityManager securityManager = System.getSecurityManager();
        if (securityManager != null) {
            int lastIndex = name.lastIndexOf(46);
            if (lastIndex != -1) {
                securityManager.checkPackageAccess(name.substring(0, lastIndex));
            }
        }
        return super.loadClass(name, resolve);
    }
    
    static {
        ClassLoader.registerAsParallelCapable();
    }
}
